Index: /data/trunk/models/doors/moonstation_elevator1a.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_elevator1a.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_elevator1a.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_elevator1a.blend
+# Material Count: 1
+newmtl Material_metal_x1_038.jpg
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd metal_x1/metal_x1_038.jpg
+
+
Index: /data/trunk/models/doors/moonstation_elevator1b.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_elevator1b.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_elevator1b.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_elevator1b.blend
+# Material Count: 1
+newmtl Material_metal_x1_038.jpg
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd metal_x1/metal_x1_038.jpg
+
+
Index: /data/trunk/models/doors/moonstation_elevator2.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_elevator2.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_elevator2.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_elevator2.blend
+# Material Count: 1
+newmtl Material_metal_x1_022.jpg
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd metal_x1/metal_x1_023.jpg
+
+
Index: /data/trunk/models/doors/moonstation_hangar_10x6.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_hangar_10x6.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_hangar_10x6.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_hangar_10x6.blend
+# Material Count: 1
+newmtl Material_moonstation_hangar_do
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd moonstation_hangar_doors.jpg
+
+
Index: /data/trunk/models/doors/moonstation_hangar_10x6b.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_hangar_10x6b.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_hangar_10x6b.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_hangar_10x6b.blend
+# Material Count: 1
+newmtl Material_moonstation_hangar_do
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd moonstation_hangar_doors.jpg
+
+
Index: /data/trunk/models/doors/moonstation_hangar_3x4.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_hangar_3x4.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_hangar_3x4.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_hangar_3x4.blend
+# Material Count: 1
+newmtl Material_moonstation_hangar_do
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd moonstation_hangar_doors.jpg
+
+
Index: /data/trunk/models/doors/moonstation_hangar_4x4.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_hangar_4x4.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_hangar_4x4.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_hangar_4x4.blend
+# Material Count: 1
+newmtl Material_moonstation_hangar_do
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd moonstation_hangar_doors.jpg
+
+
Index: /data/trunk/models/doors/moonstation_hangar_4x5.mtl
===================================================================
--- /data/trunk/models/doors/moonstation_hangar_4x5.mtl	(revision 4937)
+++ /data/trunk/models/doors/moonstation_hangar_4x5.mtl	(revision 4937)
@@ -0,0 +1,13 @@
+# Blender3D MTL File: moonstation_hangar_4x5.blend
+# Material Count: 1
+newmtl Material_moonstation_hangar_do
+Ns 96.078431
+Ka 0.000000 0.000000 0.000000
+Kd 0.640000 0.640000 0.640000
+Ks 0.500000 0.500000 0.500000
+Ni 1.000000
+d 1.000000
+illum 2
+map_Kd moonstation_hangar_doors.jpg
+
+