Index: /data/trunk/levels/sp_level_moonstation_hangar.oxw
===================================================================
--- /data/trunk/levels/sp_level_moonstation_hangar.oxw	(revision 4937)
+++ /data/trunk/levels/sp_level_moonstation_hangar.oxw	(revision 4938)
@@ -17,15 +17,15 @@
 
     <BspEntity>
-      <Name>levels/maps/moonstation/hangar044.bsp</Name>
-      <abs-coor>0, 256, 0</abs-coor>
+      <Name>levels/maps/moonstation/hangar053.bsp</Name>
+      <Transparency>0, 0</Transparency>
     </BspEntity>
 
     <FPSPlayer>
+      <damageable>true</damageable>
+      <list>group01</list>
       <name>Player</name>
       <model>models/creatures/doom_male/male.md2, 9</model>
-<!--
-      <abs-coor>-480, 20, 0</abs-coor>
+      <abs-coor>-600, 20, 0</abs-coor>
       <abs-dir>0, 0, -1, 0</abs-dir>
--->
 <!--
       <abs-coor>416, 404, 0</abs-coor>
@@ -35,11 +35,13 @@
       <abs-coor>928, 788, -192</abs-coor>
       <abs-dir>1.57, 0, 1, 0</abs-dir>
--->
+ -->
 <!--
       <abs-coor>1600, 788, 0</abs-coor>
       <abs-dir>0.57, 0, 1, 0</abs-dir>
- -->
+-->
+<!--
       <abs-coor>2880, 788, 0</abs-coor>
       <abs-dir>0.57, 0, 1, 0</abs-dir>
+-->
     </FPSPlayer>
 
@@ -213,4 +215,633 @@
 
 
+    <Mover>
+      <model>models/spaceships/human_transporter.obj, 10</model>
+      <abs-coor>4864, 900, -150</abs-coor>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-dir>1.57, 0.0, 0</rel-target-dir>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <Mover>
+      <model>models/doors/moonstation_hangar_4x5.obj, 8</model>
+      <abs-coor>5152, 1000, 736</abs-coor>
+      <abs-dir>1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>100</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>70, 0, 0</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_4x5.obj, 8</model>
+      <abs-coor>4448, 808, 736</abs-coor>
+      <abs-dir>1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>100</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>-70, 0, 0</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <Mover>
+      <model>models/doors/moonstation_hangar_10x6b.obj, 8</model>
+      <abs-coor>2944, 832, 0</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 100, 0</rel-target-coor>
+          <moving-time>1</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_10x6.obj, 9.8</model>
+      <abs-coor>3616, 832, 192</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 120, 0</rel-target-coor>
+          <moving-time>1</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_10x6.obj, 9.8</model>
+      <abs-coor>3616, 832, -192</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 120, 0</rel-target-coor>
+          <moving-time>1</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_10x6b.obj, 9.8</model>
+      <abs-coor>4032, 832, 352</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 120, 0</rel-target-coor>
+          <moving-time>1</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <moving-sound>sounds/doors/door_moving2.wav</moving-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_10x6b.obj, 9.8</model>
+      <abs-coor>4032, 832, -352</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>150</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 120, 0</rel-target-coor>
+          <moving-time>1</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <Mover>
+      <model>models/doors/moonstation_hangar_4x4.obj, 8</model>
+      <abs-coor>928, 800, -200</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>85</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>-90, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_4x4.obj, 8</model>
+      <abs-coor>928, 624, -200</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+    </Mover>
+
+
+    <Mover>
+      <model>models/doors/moonstation_hangar_4x5.obj, 10</model>
+      <abs-coor>372, 620, -128</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>100</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>-90, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <Mover>
+      <model>models/doors/moonstation_hangar_3x4.obj, 8</model>
+      <abs-coor>352, 800, 180</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>85</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>70, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_3x4.obj, 8</model>
+      <abs-coor>352, 608, 180</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>85</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>70, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_hangar_3x4.obj, 8</model>
+      <abs-coor>352, 32, 180</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <ApproachTrigger>
+          <radius>85</radius>
+        </ApproachTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>70, 0, 0</rel-target-coor>
+          <moving-time>0.75</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <ApproachTrigger>
+      <name>elevator2</name>
+      <radius>150</radius>
+      <abs-coor>464, 48, 0</abs-coor>
+    </ApproachTrigger>
+
+    <Mover>
+      <model>models/doors/moonstation_elevator1a.obj, 8</model>
+      <abs-coor>464, 48, 36</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator2</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, 23</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <delay>0.5</delay>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_elevator1a.obj, 8</model>
+      <abs-coor>464, 48, -36</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator2</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, -23</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <delay>0.5</delay>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+    <Mover>
+      <model>models/doors/moonstation_elevator1b.obj, 8</model>
+      <abs-coor>464, 48, 12</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator2</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, 46</rel-target-coor>
+          <moving-time>1.0</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_elevator1b.obj, 8</model>
+      <abs-coor>464, 48, -12</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator2</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, -46</rel-target-coor>
+          <moving-time>1.0</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <ApproachTrigger>
+      <name>elevator1</name>
+      <radius>75</radius>
+      <abs-coor>-520, 48, 0</abs-coor>
+    </ApproachTrigger>
+
+    <Mover>
+      <model>models/doors/moonstation_elevator2.obj, 8</model>
+      <abs-coor>-520, 48, 20</abs-coor>
+      <abs-dir>-1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator1</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, 35</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+    <Mover>
+      <model>models/doors/moonstation_elevator2.obj, 8</model>
+      <abs-coor>-520, 48, -20</abs-coor>
+      <abs-dir>1.57, 1, 0, 0</abs-dir>
+      <bReopen>1</bReopen>
+      <bReclose>1</bReclose>
+      <triggers>
+        <EventTrigger>
+          <event>elevator1</event>
+        </EventTrigger>
+      </triggers>
+      <stations>
+        <MoverStation>
+          <rel-target-coor>0, 0, -35</rel-target-coor>
+          <moving-time>0.5</moving-time>
+          <opening-sound>sounds/doors/door_opening2.wav</opening-sound>
+          <closing-sound>sounds/doors/door_opening2.wav</closing-sound>
+          <closed-sound>sounds/doors/door_closed2.wav</closed-sound>
+        </MoverStation>
+      </stations>
+    </Mover>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>432, 96, 528</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>400</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>896, 400, -96</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>400</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>416, 384, 0</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>400</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>1536, 768, -96</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>500</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>1536, 768, 96</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>600</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>3776, 768, 0</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>400</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>4896, 958, 592</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>500</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
+    <AdmTurret>
+      <model>models/guns/turret/turret_body.obj,10</model>
+      <list>group00</list>
+      <damageable>true</damageable>
+      <target>Player</target>
+      <abs-coor>5392, 958, -16</abs-coor>
+      <Cannons>
+        <model>models/guns/turret/turret_riffle.obj,10</model>
+        <rel-coor>0, 47, 0</rel-coor>
+      </Cannons>
+      <Sensor>
+        <model>models/guns/turret/turret_radar.obj,10</model>
+        <rel-coor>0, 32.5, 0</rel-coor>
+      </Sensor>
+      <Weapon>
+        <Range>400</Range>
+        <SetDamage>10</SetDamage>
+        <FireRate>1</FireRate>
+        <AlwaysHits>false</AlwaysHits>
+        <addPoint>-30,1,11</addPoint>
+        <addPoint>-30,1,-11</addPoint>
+      </Weapon>
+    </AdmTurret>
+
+
     <SpriteParticles>
       <name>Green Steam at Entrance</name>
@@ -1138,4 +1769,75 @@
 
 
+    <SpriteParticles>
+      <name>Big steam in hangar</name>
+      <type>sprite</type>
+      <texture>steam01.png</texture>
+      <max-count>300</max-count>
+      <life-span>8, 2</life-span>
+      <radius>0.0, 250.0, 100.0</radius>
+      <mass>0.0, 1.0, .3</mass>
+      <color>0.0, 1.0, 1.0, 1.0, 0.2</color>
+      <color>0.5, 0.6, 0.6, 0.6, 0.1</color>
+      <color>1.0, 0.0, 0.0, 0.0, 0.0</color>
+      <precache>0</precache>
+      <emitters>
+        <PlaneEmitter>
+          <name>SteamEmitter</name>
+          <rel-coor>4240, 672, 352</rel-coor>
+          <spread>0, 0.5</spread>
+          <emission-velocity>150, 10</emission-velocity>
+          <size>100, 300</size>
+          <rate>15</rate>
+        </PlaneEmitter>
+      </emitters>
+    </SpriteParticles>
+    <SpriteParticles>
+      <name>Big steam in hangar</name>
+      <type>sprite</type>
+      <texture>steam01.png</texture>
+      <max-count>300</max-count>
+      <life-span>8, 2</life-span>
+      <radius>0.0, 250.0, 100.0</radius>
+      <mass>0.0, 1.0, .3</mass>
+      <color>0.0, 1.0, 1.0, 1.0, 0.2</color>
+      <color>0.5, 0.6, 0.6, 0.6, 0.1</color>
+      <color>1.0, 0.0, 0.0, 0.0, 0.0</color>
+      <precache>0</precache>
+      <emitters>
+        <PlaneEmitter>
+          <name>SteamEmitter</name>
+          <rel-coor>5360, 672, 352</rel-coor>
+          <spread>0, 0.5</spread>
+          <emission-velocity>150, 10</emission-velocity>
+          <size>100, 300</size>
+          <rate>15</rate>
+        </PlaneEmitter>
+      </emitters>
+    </SpriteParticles>
+    <SpriteParticles>
+      <name>Big steam in hangar</name>
+      <type>sprite</type>
+      <texture>steam01.png</texture>
+      <max-count>300</max-count>
+      <life-span>8, 2</life-span>
+      <radius>0.0, 250.0, 100.0</radius>
+      <mass>0.0, 1.0, .3</mass>
+      <color>0.0, 1.0, 1.0, 1.0, 0.2</color>
+      <color>0.5, 0.6, 0.6, 0.6, 0.1</color>
+      <color>1.0, 0.0, 0.0, 0.0, 0.0</color>
+      <precache>0</precache>
+      <emitters>
+        <PlaneEmitter>
+          <name>SteamEmitter</name>
+          <rel-coor>5360, 672, -352</rel-coor>
+          <spread>0, 0.5</spread>
+          <emission-velocity>150, 10</emission-velocity>
+          <size>100, 300</size>
+          <rate>15</rate>
+        </PlaneEmitter>
+      </emitters>
+    </SpriteParticles>
+
+
     <BspEntity>
       <Name>levels/maps/moonstation/hangar_flares006.bsp</Name>
@@ -1411,5 +2113,25 @@
       <Light>
         <diffuse-color>1,1,1</diffuse-color>
-        <abs-coor>-200, 50, 0</abs-coor>
+        <abs-coor>10000, 500, 0</abs-coor>
+      </Light>
+      <Light>
+        <diffuse-color>1,1,1</diffuse-color>
+        <abs-coor>-10000, 500, 0</abs-coor>
+      </Light>
+      <Light>
+        <diffuse-color>1,1,1</diffuse-color>
+        <abs-coor>0, 10000, 0</abs-coor>
+      </Light>
+      <Light>
+        <diffuse-color>1,1,1</diffuse-color>
+        <abs-coor>0, -10000, 0</abs-coor>
+      </Light>
+      <Light>
+        <diffuse-color>1,1,1</diffuse-color>
+        <abs-coor>0, 500, 10000</abs-coor>
+      </Light>
+      <Light>
+        <diffuse-color>1,1,1</diffuse-color>
+        <abs-coor>0, 500, -10000</abs-coor>
       </Light>
     </Lights>