Index: /orxonox/trunk/COPYING
===================================================================
--- /orxonox/trunk/COPYING	(revision 4943)
+++ /orxonox/trunk/COPYING	(revision 4944)
@@ -1,4 +1,4 @@
-		    GNU GENERAL PUBLIC LICENSE
-		       Version 2, June 1991
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 2, June 1991
 
  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
@@ -7,5 +7,5 @@
  of this license document, but changing it is not allowed.
 
-			    Preamble
+                            Preamble
 
   The licenses for most software are designed to take away your
@@ -57,6 +57,5 @@
 modification follow.
 
-
-		    GNU GENERAL PUBLIC LICENSE
+                    GNU GENERAL PUBLIC LICENSE
    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 
@@ -113,5 +112,4 @@
     the Program is not required to print an announcement.)
 
-
 These requirements apply to the modified work as a whole.  If
 identifiable sections of that work are not derived from the Program,
@@ -171,5 +169,4 @@
 distribution of the source code, even though third parties are not
 compelled to copy the source along with the object code.
-
 
   4. You may not copy, modify, sublicense, or distribute the Program
@@ -230,5 +227,4 @@
 be a consequence of the rest of this License.
 
-
   8. If the distribution and/or use of the Program is restricted in
 certain countries either by patents or by copyrighted interfaces, the
@@ -260,5 +256,5 @@
 of promoting the sharing and reuse of software generally.
 
-			    NO WARRANTY
+                            NO WARRANTY
 
   11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
@@ -282,8 +278,7 @@
 POSSIBILITY OF SUCH DAMAGES.
 
-		     END OF TERMS AND CONDITIONS
-
-
-	    How to Apply These Terms to Your New Programs
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
 
   If you develop a new program, and you want it to be of the greatest
Index: /orxonox/trunk/INSTALL
===================================================================
--- /orxonox/trunk/INSTALL	(revision 4943)
+++ /orxonox/trunk/INSTALL	(revision 4944)
@@ -19,23 +19,28 @@
 There are some dependencies for orxonox you have to install:
 
-1. SDL           (http://www.libsdl.org)
-2. OPENGL        (http://www.opengl.org)
-3. OPENAL        (http://www.openal.org)
-4. SDL_image     (http://www.libsdl.org/projects/SDL_image)
-5. SDL_ttf       (http://www.libsdl.org/projects/SDL_ttf)
+01. SDL           (http://www.libsdl.org)
+02. OPENGL        (http://www.opengl.org)
+03. OPENAL        (http://www.openal.org)
+04. SDL_image     (http://www.libsdl.org/projects/SDL_image)
+05. SDL_ttf       (http://www.libsdl.org/projects/SDL_ttf)
  a) needs libttf (http://www.freetype.org/)
 
 Nice to Have:
-6. Doxygen       (http://www.stack.nl/~dimitri/doxygen/)
-7. Automake      (http://www.gnu.org/software/automake/)
-8. Autoconf      (http://www.gnu.org/software/autoconf/)
+06. Doxygen       (http://www.stack.nl/~dimitri/doxygen/)
+07. Automake      (http://www.gnu.org/software/automake/)
+08. Autoconf      (http://www.gnu.org/software/autoconf/)
 
 Windows Users also need the following:
-9. mingw         (http://mingw.org/)
-
+09. mingw         (http://mingw.org/)
+
+10. more answers to your questions can be found under section
+    wiki on our webpage http://www.orxonox.net
 
 BUGS
 ====
 Send bug reports to <orxonox-dev@mail.datacore.ch>
+
+
+
 
 ORXONOX->
Index: /orxonox/trunk/README
===================================================================
--- /orxonox/trunk/README	(revision 4943)
+++ /orxonox/trunk/README	(revision 4944)
@@ -13,5 +13,5 @@
 Orxonox is a open-source vertical scroller game programed
 in c++ and OpenGL.
-If we manage to be sober enough, this game shall definitly 
+If we manage to be sober enough, this game shall definitly
 become _the_ open-source vertical scroller ever.
 
@@ -40,9 +40,9 @@
 ------------------------------
 People who want to help us working on orxonox are always
-welcome:) Feel free to chip in anything you like. Wine, beer, 
+welcome:) Feel free to chip in anything you like. Wine, beer,
 coffee... If you like to help us programming orxonox, you:
 - join the developer community mailing lists
 - read this README file
-then you have multiple ways to get started. 
+then you have multiple ways to get started.
 a) Read the hole source code and choose a topic you like
 b) check the TODO file to get a knowledge of what we need
@@ -51,10 +51,10 @@
 read the programming sections below.
 
-To start programming on orxonox you first have to download the 
+To start programming on orxonox you first have to download the
 newest svn tree of orxonox. You can do this by enterning following
 lines in the linux console (ensure svn to be installed with ssl
 support enabled):
 
-svn co https://open.datacore.ch/pw/orxonox orxonox
+svn co https://svn.orxonox.net/reporx/orxonox orxonox
 
 If you haven't got ssl support in you svn tool, recompile it
@@ -67,5 +67,5 @@
 ------------------------
 If you are new to c/c++ programming, this project is probably
-not the best starting place to learn it. For you and the rest who 
+not the best starting place to learn it. For you and the rest who
 need "refreshment" check out these guides:
 
@@ -80,14 +80,14 @@
 
 SVN (=subversion) is a version control program similar to CVS but
-newer. This program enables us to work all at the same program at 
+newer. This program enables us to work all at the same program at
 the same time - tricky.
 
-subversion checkout https://open.datacore.ch/pw/orxonox orxonox
-same as: subversion co https://open.datacore....
+subversion checkout https://svn.orxonox.net/reporx/orxonox orxonox
+same as: subversion co https://svn.orxonox.net.....
 
 this makes a directory orxonox at your current place in and gets
 the hole brand new source code from the server.
 
-now you can work. Remember to use 'svn copy instead of 'cp', 
+now you can work. Remember to use 'svn copy instead of 'cp',
 'svn mv' instead of 'mv', 'svn rm' instead of 'rm'... - you got it
 I think.
@@ -108,6 +108,6 @@
 and to publish all your changes type
 svn commit --message "Corrected number of chees slices."
-svn commit will send all of your changs to the repository. When you 
-commit a change, you need to supply a log message, describing your 
+svn commit will send all of your changs to the repository. When you
+commit a change, you need to supply a log message, describing your
 change. The message can also be read from a file:
 svn commit --file logmsg
@@ -127,6 +127,6 @@
 the two versions will merge.
 
-If you are working on orxonox you will have your own branch in which you 
-will program, some sort of sand-box. If you finish your work on your 
+If you are working on orxonox you will have your own branch in which you
+will program, some sort of sand-box. If you finish your work on your
 topic, it will be revised by us and merged with the trunk
 
Index: xonox/trunk/TASKS
===================================================================
--- /orxonox/trunk/TASKS	(revision 4943)
+++ 	(revision )
@@ -1,14 +1,0 @@
-Name: 			Animation/movie Player
-Date:			02.11.04
-Type of Work: 		design, implementation/coding, graphics
-Prerequirements:	C++(50%), OpenGL(30%), Graphics(20%)
-Priority: 		3
-Workprogress:	 	0%
-Abstract:		A method to play animations like explosions/water/wapeons during the game on the game-screen. <br>Abspielen einer bilderfolge an einem beliebigen Ort im Bildschirm. It is also possible to show fullscreen cinematics.
-Eingabe-Ausgabe:	Type of Data: Class/Function<br>Eingang: what to play, where to play, dataformat z.B. explosion1.avi, new Location(100, 245, 543), avi<br>Ausgang: animation playing on screen.
-Anwendungszwecke: 	Racketen/Lasers die abgeschossen werden (waffen die sich bewegen, gluehen)<br>Explosionen im Fall von Kollisionen/Einschlaegen<br>Umgebung wie Wasser, Gras etc
-Ansprueche:		Eine Animation ist ein Teil einer WorldEntity<br>Eine WorldEntity kann meherere Animationen beinhalten und gleichzeitig abspielen<br>Die WE muss wissen was fuer Animationen in welcher Situation abgespielt werden muessen.<br>SpeicherFormat<br>frei, muss aber open-source "kompatibel" sein. (also nicht jpeg)<br>balance aus speicherschonend und billig zu dekodieren<br>Animation muss sich mit der WorldEntity mitbewegen<br>Animation kann sich in der groesse veraendern<br>Transparente effekte
-Implementierung:	Eine Animation gehert einer WorldEntity (einleuchtend, denn ein spieler entscheidet wann geschossen  werden muss und damit eine animation dargestellt werden muss). Somit beinhaltet eine WorldEntity eine Klasse Animation. Diese Klasse hat eine liste der momentan laufenden Animationen<br>Aehnlich wie die WorldEntity::draw() function wird eine Animation::draw() function aufgerufen, im gleichen Takt.
-Offene Fragen:		Hintergrund nicht verdecken mit der Animation (v.a. an den Ecken aufpassen)<br>Was fuer eine Art Datenformat muss verwendet werden um die animationen effizient darzustellen.
-	
-
Index: /orxonox/trunk/ToDo
===================================================================
--- /orxonox/trunk/ToDo	(revision 4943)
+++ /orxonox/trunk/ToDo	(revision 4944)
@@ -1,12 +1,24 @@
+ToDo:
+-----
+There are many tasks still open in orxonox.
 
+1. TASKS
+--------
+Best idea is, to visit our Webpage at: http://www.orxonox.net and
+under the wiki link follow RoadMap, and from there on you will find many tasks
+or just use this link:
+https://www.orxonox.net/cgi-bin/trac.cgi/roadmap
 
+2. ToDo-list
+------------
+see the Doxygen documetation for a List of todo's
+or visit the Code, you have with you (or a more actual version found at
+http://svn.orxonox.net/reporx/orxonox/trunk) for all the ToDo's
+The easiest way to find ToDo's is to make the following in the trunk:
+grep @todo * -R
 
-orxonox:
+3. FIXME
 --------
-
-#define "objModel.h" has nothing todo in world_entity.h
-
-Collision Detection: SetObjectCollisionBox( void );
-
-
-
+They can be found with
+grep FIXME * -R
+in the trunk.
Index: /orxonox/trunk/configure.ac
===================================================================
--- /orxonox/trunk/configure.ac	(revision 4943)
+++ /orxonox/trunk/configure.ac	(revision 4944)
@@ -17,4 +17,6 @@
 #   It is quite fragile, and compiling orxonox on different Platforms    #
 #   is only guarantied, if build with the right config.                  #
+#                                                                        #
+#   be sure to visit us at http://www.orxonox.net                        #
 ##########################################################################
 
Index: /orxonox/trunk/doc/CREDITS
===================================================================
--- /orxonox/trunk/doc/CREDITS	(revision 4943)
+++ /orxonox/trunk/doc/CREDITS	(revision 4944)
@@ -1,6 +1,4 @@
-
-
-The Orxonox Team Thanks To 
---------------------------
+The orxonox Team Thanks the following brethren.
+-----------------------------------------------
 
 Programmers:
@@ -11,9 +9,12 @@
 Infrastructure:
 ---------------
-amir@datacore.ch	for giving us access to subversion and mailing lists
+amir@datacore.ch        for giving us access to subversion and mailing lists
 
 The Great Orx Sound:
 --------------------
-Luke Grey		for making the orxonox sound
+Luke Grey               for making the orxonox sound
+Thierry Zaugg           many songs
 
 
+
+And many many more....
Index: /orxonox/trunk/scripts/data.checkout
===================================================================
--- /orxonox/trunk/scripts/data.checkout	(revision 4943)
+++ /orxonox/trunk/scripts/data.checkout	(revision 4944)
@@ -3,6 +3,6 @@
 if [ -z "$1" ]
 then
-    svn co https://svn.orxonox.ethz.ch/data data
+    svn co https://svn.orxonox.net/data data
 else
-    svn co https://svn.orxonox.ethz.ch/data data --username $1
+    svn co https://svn.orxonox.net/data data --username $1
 fi
Index: /orxonox/trunk/scripts/gentoo/orxonox-0.3.0_alpha-r4775.ebuild
===================================================================
--- /orxonox/trunk/scripts/gentoo/orxonox-0.3.0_alpha-r4775.ebuild	(revision 4943)
+++ /orxonox/trunk/scripts/gentoo/orxonox-0.3.0_alpha-r4775.ebuild	(revision 4944)
@@ -8,7 +8,7 @@
 
 DESCRIPTION="orxonox is an open-source vertical scroller game programmed in C++, OpenGL, OpenAL and SDL"
-HOMEPAGE="http://www.orxonox.ethz.ch"
-SRC_URI="http://www.orxonox.ethz.ch/files/snapshots/${P}-${PR}.tar.bz2
-         http://www.orxonox.ethz.ch/files/snapshots/${PN}-data-r${DATA_VERSION}.tar.bz2"
+HOMEPAGE="http://www.orxonox.net"
+SRC_URI="http://www.orxonox.net/files/snapshots/${P}-${PR}.tar.bz2
+         http://www.orxonox.net/files/snapshots/${PN}-data-r${DATA_VERSION}.tar.bz2"
 LICENSE="GPL-2"
 SLOT="0"
@@ -34,28 +34,28 @@
 
 src_compile() {
-	egamesconf || die
+        egamesconf || die
 
-	emake || die "emake failed"
+        emake || die "emake failed"
 }
 
 src_install() {
-	make DESTDIR=${D} install || die
-	
-	dodir ${GAMES_DATADIR}/${PN}
-	cp -r data/* ${D}/${GAMES_DATADIR}/${PN}/ \
-		|| die "data copy failed"
-	
-	dodoc AUTHORS ChangeLog README
+        make DESTDIR=${D} install || die
 
-	prepgamesdirs
+        dodir ${GAMES_DATADIR}/${PN}
+        cp -r data/* ${D}/${GAMES_DATADIR}/${PN}/ \
+                || die "data copy failed"
 
-	#make \
-	#	prefix=${D}/usr \
-	#	mandir=${D}/usr/share/man \
-	#	infodir=${D}/usr/share/info \
-	#	libdir=${D}/usr/$(get_libdir) \
-	#	install || die
+        dodoc AUTHORS ChangeLog README
 
-	#einstall || die
+        prepgamesdirs
+
+        #make \
+        #       prefix=${D}/usr \
+        #       mandir=${D}/usr/share/man \
+        #       infodir=${D}/usr/share/info \
+        #       libdir=${D}/usr/$(get_libdir) \
+        #       install || die
+
+        #einstall || die
 }
 
Index: /orxonox/trunk/src/defs/globals.h
===================================================================
--- /orxonox/trunk/src/defs/globals.h	(revision 4943)
+++ /orxonox/trunk/src/defs/globals.h	(revision 4944)
@@ -12,10 +12,11 @@
 
 
-#define ORXONOX_STAFF "Patrick Boenzli - Captain\n" \
-                      "Benjamin Grauer - First Officer\n" \
-                      "Christian Meyer - Engeneer\n" \
-                      "Nico Bernold - Physics\n" \
-                      "David Gruetter - The ProtoType\n" \
-                      "many more...\n"
+#define   ORXONOX_STAFF "Patrick Boenzli - Captain\n" \
+                        "Benjamin Grauer - First Officer\n" \
+                        "Christian Meyer - Engeneer\n" \
+                        "Nico Bernold - Physics\n" \
+                        "David Gruetter - The ProtoType\n" \
+                        "many more...\n"
+#define   ORXONOX_WEBPAGE                  "http://www.orxonox.net"
 
 #define   DEFAULT_CONFIG_FILE              "~/.orxonox/orxonox.conf"
Index: /orxonox/trunk/src/lib/gui/gui_update.cc
===================================================================
--- /orxonox/trunk/src/lib/gui/gui_update.cc	(revision 4943)
+++ /orxonox/trunk/src/lib/gui/gui_update.cc	(revision 4944)
@@ -265,5 +265,5 @@
 
   dataInfo->fileName = "02%20orxonox%203.mp3";
-  dataInfo->webRoot  = "http://www.orxonox.ethz.ch/files/";
+  dataInfo->webRoot  = "http://www.orxonox.net/files/";
   dataInfo->localRoot = "./";
   PRINTF(4)("Preparing to download file %s.\n", dataInfo->fileName);
Index: /orxonox/trunk/src/lib/gui/gui_update.h
===================================================================
--- /orxonox/trunk/src/lib/gui/gui_update.h	(revision 4943)
+++ /orxonox/trunk/src/lib/gui/gui_update.h	(revision 4944)
@@ -38,5 +38,5 @@
 
   bool getSystemInfo();
- 
+
   // Window creation.
   Frame* updateFrame;                   //!< The Frame that holds the updateOptions.
@@ -44,5 +44,5 @@
   CheckButton* autoUpdate;              //!< A Checkbutton to enable the automatic Updating.
 
-  
+
   Button* updateDataWindowButton;       //!< A Button to update the Data of orxonox.
   Window* updateDataWindow;             //!< A Window for the data-update.
@@ -84,7 +84,7 @@
 
   static CURL* curlHandle;
-#ifdef HAVE_GTK2 
+#ifdef HAVE_GTK2
   static gint cancelDownload(GtkWidget* w, GdkEventKey* event, void* bar);
-#endif /* HAVE_GTK2 */  
+#endif /* HAVE_GTK2 */
   static bool isDownloading;
   static bool downloadCanceled;
@@ -95,5 +95,5 @@
   static void* downloadThreadFinished(void* fileInfo);
 
-  
+
 #endif /* HAVE_CURL */
 
@@ -101,6 +101,6 @@
   GuiUpdate();
   ~GuiUpdate();
-  
-#ifdef HAVE_CURL   
+
+#ifdef HAVE_CURL
   void updateDataWindowCreate();
   Button* updateDataWindowGetButton();
@@ -110,5 +110,5 @@
 
   bool* checkForUpdates();
- 
+
 #endif /* HAVE_CURL */
 