Index: orxonox/trunk/src/world_entities/weapons/projectile.cc
===================================================================
--- orxonox/trunk/src/world_entities/weapons/projectile.cc	(revision 4947)
+++ orxonox/trunk/src/world_entities/weapons/projectile.cc	(revision 4948)
@@ -52,4 +52,20 @@
   */
   //delete this->projectileModel;
+}
+
+
+void Projectile::setEnergies(float energyMin, float energyMax)
+{
+  this->energyMin = energyMin;
+  if (energyMax <= energyMin)
+  {
+    this->bChargeable = false;
+    this->energyMax = energyMin;
+  }
+  else
+  {
+    this->bChargeable = true;
+    this->energyMax = energyMax;
+  }
 }
 
Index: orxonox/trunk/src/world_entities/weapons/projectile.h
===================================================================
--- orxonox/trunk/src/world_entities/weapons/projectile.h	(revision 4947)
+++ orxonox/trunk/src/world_entities/weapons/projectile.h	(revision 4948)
@@ -24,5 +24,4 @@
 #include "vector.h"
 
-class Vector;
 class ParticleEmitter;
 
@@ -38,4 +37,12 @@
 
 
+    void setEnergies(float energyMin, float energyMax);
+    /** @returns the minimal charched energy */
+    inline float getEnergyMin() { return this->energyMin; };
+    /** @returns the maximal charched energy */
+    inline float getEnergyMax() { return this->energyMax; };
+    /** @returns if the Projectile can be charged */
+    inline bool isChageable() { return this->bChargeable; };
+
 
 
@@ -50,10 +57,10 @@
     float                 energyMin;
     float                 energyMax;
-
+    bool                  bChargeable;               //!< if the Projectile is Charegeable
 
     float                 lifeCycle;                 //!< The percentage of the Lifetime done [0-1]
     float                 lifeSpan;                  //!< The entire lifespan of the Shoot. in seconds
 
-    Vector                flightDirection;           //!< direction in which the shoot flighs
+    Vector                flightDirection;           //!< DOF direction in which the shoot flighs
 
     Vector                velocity;                  //!< velocity of the projectile.
Index: orxonox/trunk/src/world_entities/weapons/test_bullet.cc
===================================================================
--- orxonox/trunk/src/world_entities/weapons/test_bullet.cc	(revision 4947)
+++ orxonox/trunk/src/world_entities/weapons/test_bullet.cc	(revision 4948)
@@ -35,6 +35,9 @@
   this->setClassID(CL_TEST_BULLET, "TestBullet");
 
-  float modelSize = .5;
+  float modelSize = .3;
   this->model = (Model*)ResourceManager::getInstance()->load("models/orx-rocket.obj", OBJ, RP_LEVEL, (void*) &modelSize);
+
+  this->energyMin = 1;
+  this->energyMax = 10;
 }
 
Index: orxonox/trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- orxonox/trunk/src/world_entities/weapons/test_gun.cc	(revision 4947)
+++ orxonox/trunk/src/world_entities/weapons/test_gun.cc	(revision 4948)
@@ -113,5 +113,5 @@
 
   this->setProjectile(CL_TEST_BULLET);
-  this->getProjectileFactory()->prepare(100);
+  //this->getProjectileFactory()->prepare(100);
 }
 
Index: orxonox/trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- orxonox/trunk/src/world_entities/weapons/weapon.cc	(revision 4947)
+++ orxonox/trunk/src/world_entities/weapons/weapon.cc	(revision 4948)
@@ -25,9 +25,8 @@
 #include "class_list.h"
 #include "load_param.h"
+#include "state.h"
+#include "sound_engine.h"
+#include "animation3d.h"
 #include "vector.h"
-#include "list.h"
-#include "state.h"
-#include "animation3d.h"
-#include "sound_engine.h"
 
 ////////////////////
@@ -108,4 +107,13 @@
   if (this->projectileFactory == NULL)
     return false;
+  else
+  {
+    // grabbing Parameters from the Projectile to have them at hand here.
+    this->projectileFactory->prepare(1);
+    Projectile* pj = dynamic_cast<Projectile*>(this->projectileFactory->resurrect());
+    this->minCharge = pj->getEnergyMin();
+    this->maxCharge = pj->getEnergyMax();
+    this->chargeable = pj->isChageable();
+  }
 };
 